## scylladb-scylladb.zip

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.27)

project(scylla)

list(APPEND CMAKE_MODULE_PATH
  ${CMAKE_CURRENT_SOURCE_DIR}/cmake
  ${CMAKE_CURRENT_SOURCE_DIR}/seastar/cmake)

# Set the possible values of build type for cmake-gui
set(scylla_build_types
    "Debug" "RelWithDebInfo" "Dev" "Sanitize" "Coverage")
if(DEFINED CMAKE_BUILD_TYPE)
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
     ${scylla_build_types})
    if(NOT CMAKE_BUILD_TYPE)
        set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE
            STRING "Choose the type of build." FORCE)
        message(WARNING "CMAKE_BUILD_TYPE not specified, Using 'RelWithDebInfo'")
    elseif(NOT CMAKE_BUILD_TYPE IN_LIST scylla_build_types)
        message(FATAL_ERROR "Unknown CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}. "
            "Following types are supported: ${scylla_build_types}")
    endif()
endif(DEFINED CMAKE_BUILD_TYPE)

include(mode.common)
get_property(is_multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if(is_multi_config)
    foreach(config ${CMAKE_CONFIGURATION_TYPES})
        include(mode.${config})
        list(APPEND scylla_build_modes ${scylla_build_mode_${config}})
    endforeach()
    add_custom_target(mode_list
        COMMAND ${CMAKE_COMMAND} -E echo "$<JOIN:${scylla_build_modes}, >"
        COMMENT "List configured modes"
        BYPRODUCTS mode-list.phony.stamp
        COMMAND_EXPAND_LISTS)
else()
    include(mode.${CMAKE_BUILD_TYPE})
    add_custom_target(mode_list
        ${CMAKE_COMMAND} -E echo "${scylla_build_mode}"
        COMMENT "List configured modes")
endif()

include(limit_jobs)
# Configure Seastar compile options to align with Scylla
set(CMAKE_CXX_STANDARD "23" CACHE INTERNAL "")
set(CMAKE_CXX_EXTENSIONS ON CACHE INTERNAL "")
set(CMAKE_CXX_SCAN_FOR_MODULES OFF CACHE INTERNAL "")
set(CMAKE_CXX_VISIBILITY_PRESET hidden)

if(is_multi_config)
    find_package(Seastar)
    # this is atypical compared to standard ExternalProject usage:
    # - Seastar's build system should already be configured at this point.
    # - We maintain separate project variants for each configuration type.
    #
    # Benefits of this approach:
    # - Allows the parent project to consume the compile options exposed by
    #   .pc file. as the compile options vary from one config to another.
    # - Allows application of config-specific settings
    # - Enables building Seastar within the parent project's build system
    # - Facilitates linking of artifacts with the external project target,
    #   establishing proper dependencies between them
    include(ExternalProject)

    ExternalProject_Add(Seastar
        SOURCE_DIR "${PROJECT_SOURCE_DIR}/seastar"
        BINARY_DIR "${CMAKE_BINARY_DIR}/$<CONFIG>/seastar"
        CONFIGURE_COMMAND ""
        BUILD_COMMAND ${CMAKE_COMMAND} --build <BINARY_DIR>
          --target seastar
          --target seastar_testing
          --target seastar_perf_testing
          --target app_iotune
        BUILD_ALWAYS ON
        BUILD_BYPRODUCTS
          <BINARY_DIR>/libseastar.$<IF:$<CONFIG:Debug,Dev>,so,a>
          <BINARY_DIR>/libseastar_testing.$<IF:$<CONFIG:Debug,Dev>,so,a>
          <BINARY_DIR>/libseastar_perf_testing.$<IF:$<CONFIG:Debug,Dev>,so,a>
          <BINARY_DIR>/apps/iotune/iotune
          <BINARY_DIR>/gen/include/seastar/http/chunk_parsers.hh
          <BINARY_DIR>/gen/include/seastar/http/request_parser.hh
          <BINARY_DIR>/gen/include/seastar/http/response_parser.hh
        INSTALL_COMMAND "")
    add_dependencies(Seastar::seastar Seastar)
    add_dependencies(Seastar::seastar_testing Seastar)
else()
    set(Seastar_TESTING ON CACHE BOOL "" FORCE)
    set(Seastar_API_LEVEL 7 CACHE STRING "" FORCE)
    set(Seastar_DEPRECATED_OSTREAM_FORMATTERS OFF CACHE BOOL "" FORCE)
    set(Seastar_APPS ON CACHE BOOL "" FORCE)
    set(Seastar_EXCLUDE_APPS_FROM_ALL ON CACHE BOOL "" FORCE)
    set(Seastar_EXCLUDE_TESTS_FROM_ALL ON CACHE BOOL "" FORCE)
    set(Seastar_IO_URING ON CACHE BOOL "" FORCE)
    set(Seastar_SCHEDULING_GROUPS_COUNT 16 CACHE STRING "" FORCE)
    set(Seastar_UNUSED_RESULT_ERROR ON CACHE BOOL "" FORCE)
    add_subdirectory(seastar)
    target_compile_definitions (seastar
      PRIVATE
        SEASTAR_NO_EXCEPTION_HACK)
endif()

set(ABSL_PROPAGATE_CXX_STD ON CACHE BOOL "" FORCE)

find_package(Sanitizers QUIET)
set(sanitizer_cxx_flags
    $<$<CONFIG:Debug,Sanitize>:$<TARGET_PROPERTY:Sanitizers::address,INTERFACE_COMPILE_OPTIONS>;$<TARGET_PROPERTY:Sanitizers::undefined_behavior,INTERFACE_COMPILE_OPTIONS>>)
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(ABSL_GCC_FLAGS ${sanitizer_cxx_flags})
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(ABSL_LLVM_FLAGS ${sanitizer_cxx_flags})
endif()
set(ABSL_DEFAULT_LINKOPTS
    $<$<CONFIG:Debug,Sanitize>:$<TARGET_PROPERTY:Sanitizers::address,INTERFACE_LINK_LIBRARIES>;$<TARGET_PROPERTY:Sanitizers::undefined_behavior,INTERFACE_LINK_LIBRARIES>>)
add_subdirectory(abseil)
add_library(absl-headers INTERFACE)
target_include_directories(absl-headers SYSTEM INTERFACE
    "${PROJECT_SOURCE_DIR}/abseil")
add_library(absl::headers ALIAS absl-headers)

# Exclude absl::strerror from the default "all" target since it's not
# used in Scylla build and, moreover, makes use of deprecated glibc APIs,
# such as sys_nerr, which are not exposed from "stdio.h" since glibc 2.32,
# which happens to be the case for recent Fedora distribution versions.
#
# Need to use the internal "absl_strerror" target name instead of namespaced
# variant because `set_target_properties` does not understand the latter form,
# unfortunately.
set_target_properties(absl_strerror PROPERTIES EXCLUDE_FROM_ALL TRUE)

# System libraries dependencies
find_package(Boost REQUIRED
    COMPONENTS filesystem program_options system thread regex unit_test_framework)
target_link_libraries(Boost::regex
  INTERFACE
    ICU::i18n
    ICU::uc)
find_package(Lua REQUIRED)
find_package(ZLIB REQUIRED)
find_package(ICU COMPONENTS uc i18n REQUIRED)
find_package(fmt 10.0.0 REQUIRED)
find_package(libdeflate REQUIRED)
find_package(libxcrypt REQUIRED)
find_package(Snappy REQUIRED)
find_package(RapidJSON REQUIRED)
find_package(xxHash REQUIRED)
find_package(yaml-cpp REQUIRED)
find_package(zstd REQUIRED)

set(scylla_gen_build_dir "${CMAKE_BINARY_DIR}/gen")
file(MAKE_DIRECTORY "${scylla_gen_build_dir}")

include(add_version_library)
generate_scylla_version()

add_library(scylla-zstd STATIC
    zstd.cc)
target_link_libraries(scylla-zstd
  PRIVATE
    db
    Seastar::seastar
    zstd::libzstd)

add_library(scylla-main STATIC)
target_sources(scylla-main
  PRIVATE
    absl-flat_hash_map.cc
    bytes.cc
    client_data.cc
    clocks-impl.cc
    collection_mutation.cc
    compress.cc
    converting_mutation_partition_applier.cc
    counters.cc
    direct_failure_detector/failure_detector.cc
    duration.cc
    exceptions/exceptions.cc
    frozen_schema.cc
    generic_server.cc
    debug.cc
    init.cc
    keys.cc
    multishard_mutation_query.cc
    mutation_query.cc
    node_ops/task_manager_module.cc
    partition_slice_builder.cc
    querier.cc
    query.cc
    query_ranges_to_vnodes.cc
    query-result-set.cc
    tombstone_gc_options.cc
    tombstone_gc.cc
    reader_concurrency_semaphore.cc
    row_cache.cc
    schema_mutations.cc
    serializer.cc
    sstables_loader.cc
    table_helper.cc
    tasks/task_handler.cc
    tasks/task_manager.cc
    timeout_config.cc
    unimplemented.cc
    validation.cc
    vint-serialization.cc)
target_link_libraries(scylla-main
  PRIVATE
    "$<LINK_LIBRARY:WHOLE_ARCHIVE,scylla-zstd>"
    db
    absl::headers
    absl::btree
    absl::hash
    absl::raw_hash_set
    Seastar::seastar
    Snappy::snappy
    systemd
    ZLIB::ZLIB)

option(Scylla_CHECK_HEADERS
  "Add check-headers target for checking the self-containness of headers")
if(Scylla_CHECK_HEADERS)
    add_custom_target(check-headers)
    # compatibility target used by CI, which builds "check-headers" only for
    # the "Dev" mode.
    # our CI currently builds "dev-headers" using ninja without specify a build
    # mode. where "dev" is actually a prefix encoded in the target name for the
    # underlying "headers" target. while we don't have this convention in CMake
    # targets. in contrast, the "check-headers" which is built for all
    # configurations defined by "CMAKE_DEFAULT_CONFIGS". however, we only need
    # to build "check-headers" for the "Dev" configuration. Therefore, before
    # updating the CI to use build "check-headers:Dev", let's add a new target
    # that specifically builds "check-headers" only for Dev configuration. The
    # new target will do nothing for other configurations.
    add_custom_target(dev-headers
        COMMAND ${CMAKE_COMMAND}
          "$<IF:$<CONFIG:Dev>,--build;${CMAKE_BINARY_DIR};--config;$<CONFIG>;--target;check-headers,-E;echo;skipping;dev-headers;in;$<CONFIG>>"
        COMMAND_EXPAND_LISTS)
endif()

include(check_headers)
check_headers(check-headers scylla-main
  GLOB ${CMAKE_CURRENT_SOURCE_DIR}/*.hh)

option(Scylla_DIST
  "Build dist targets"
  ON)

add_custom_target(compiler-training)

add_subdirectory(api)
add_subdirectory(alternator)
add_subdirectory(db)
add_subdirectory(auth)
add_subdirectory(cdc)
add_subdirectory(compaction)
add_subdirectory(cql3)
add_subdirectory(data_dictionary)
add_subdirectory(dht)
add_subdirectory(gms)
add_subdirectory(idl)
add_subdirectory(index)
add_subdirectory(lang)
add_subdirectory(locator)
add_subdirectory(message)
add_subdirectory(mutation)
add_subdirectory(mutation_writer)
add_subdirectory(node_ops)
add_subdirectory(readers)
add_subdirectory(redis)
add_subdirectory(replica)
add_subdirectory(raft)
add_subdirectory(repair)
add_subdirectory(rust)
add_subdirectory(schema)
add_subdirectory(service)
add_subdirectory(sstables)
add_subdirectory(streaming)
add_subdirectory(test)
add_subdirectory(tools)
add_subdirectory(tracing)
add_subdirectory(transport)
add_subdirectory(types)
add_subdirectory(utils)
add_version_library(scylla_version
    release.cc)

add_executable(scylla
  main.cc)
target_link_libraries(scylla PRIVATE
    scylla-main
    api
    auth
    alternator
    db
    cdc
    compaction
    cql3
    data_dictionary
    dht
    gms
    idl
    index
    lang
    locator
    message
    mutation
    mutation_writer
    raft
    readers
    redis
    repair
    replica
    schema
    scylla_version
    service
    sstables
    streaming
    test-perf
    tools
    tracing
    transport
    types
    utils)

target_link_libraries(scylla PRIVATE
    Seastar::seastar
    absl::headers
    yaml-cpp::yaml-cpp
    Boost::program_options)

target_include_directories(scylla PRIVATE
    "${CMAKE_CURRENT_SOURCE_DIR}"
    "${scylla_gen_build_dir}")

add_custom_target(maybe-scylla
  DEPENDS $<$<CONFIG:Dev>:$<TARGET_FILE:scylla>>)
add_dependencies(compiler-training
  maybe-scylla)

if(Scylla_DIST)
  add_subdirectory(dist)
endif()

=== alternator/CMakeLists.txt ===
include(generate_cql_grammar)
generate_cql_grammar(
  GRAMMAR expressions.g
  SOURCES cql_grammar_srcs)

add_library(alternator STATIC)
target_sources(alternator
  PRIVATE
    controller.cc
    server.cc
    executor.cc
    stats.cc
    serialization.cc
    expressions.cc
    conditions.cc
    auth.cc
    streams.cc
    consumed_capacity.cc
    ttl.cc
    ${cql_grammar_srcs})
target_include_directories(alternator
  PUBLIC
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}
  PRIVATE
    ${RAPIDJSON_INCLUDE_DIRS})
target_link_libraries(alternator
  PUBLIC
    Seastar::seastar
    xxHash::xxhash
  PRIVATE
    cql3
    idl
    absl::headers)

check_headers(check-headers alternator
  GLOB_RECURSE ${CMAKE_CURRENT_SOURCE_DIR}/*.hh)

=== api/CMakeLists.txt ===
# Generate C++ sources from Swagger definitions

function(generate_swagger)
  set(one_value_args TARGET VAR IN_FILE OUT_DIR)
  cmake_parse_arguments(args "" "${one_value_args}" "" ${ARGN})
  get_filename_component(in_file_name ${args_IN_FILE} NAME)
  set(generator ${PROJECT_SOURCE_DIR}/seastar/scripts/seastar-json2code.py)
  set(header_out ${args_OUT_DIR}/${in_file_name}.hh)
  set(source_out ${args_OUT_DIR}/${in_file_name}.cc)

  add_custom_command(
    DEPENDS
      ${args_IN_FILE}
      ${generator}
    OUTPUT ${header_out} ${source_out}
    COMMAND ${CMAKE_COMMAND} -E make_directory ${args_OUT_DIR}
    COMMAND ${generator} --create-cc -f ${args_IN_FILE} -o ${header_out})

  add_custom_target(${args_TARGET}
    DEPENDS
      ${header_out}
      ${source_out})

  set(${args_VAR} ${header_out} ${source_out} PARENT_SCOPE)
endfunction()

set(swagger_files
  api-doc/authorization_cache.json
  api-doc/cache_service.json
  api-doc/collectd.json
  api-doc/column_family.json
  api-doc/commitlog.json
  api-doc/compaction_manager.json
  api-doc/config.json
  api-doc/cql_server_test.json
  api-doc/endpoint_snitch_info.json
  api-doc/error_injection.json
  api-doc/failure_detector.json
  api-doc/gossiper.json
  api-doc/hinted_handoff.json
  api-doc/lsa.json
  api-doc/messaging_service.json
  api-doc/metrics.json
  api-doc/raft.json
  api-doc/storage_proxy.json
  api-doc/storage_service.json
  api-doc/stream_manager.json
  api-doc/system.json
  api-doc/tasks.json
  api-doc/task_manager.json
  api-doc/task_manager_test.json
  api-doc/utils.json)

foreach(f ${swagger_files})
  get_filename_component(fname "${f}" NAME_WE)
  get_filename_component(dir "${f}" DIRECTORY)
  generate_swagger(
    TARGET scylla_swagger_gen_${fname}
    VAR scylla_swagger_gen_${fname}_files
    IN_FILE "${CMAKE_CURRENT_SOURCE_DIR}/${f}"
    OUT_DIR "${scylla_gen_build_dir}/api/${dir}")
  list(APPEND swagger_gen_files "${scylla_swagger_gen_${fname}_files}")
endforeach()

add_library(api STATIC)
target_sources(api
  PRIVATE
    api.cc
    cache_service.cc
    collectd.cc
    column_family.cc
    commitlog.cc
    compaction_manager.cc
    config.cc
    cql_server_test.cc
    endpoint_snitch.cc
    error_injection.cc
    authorization_cache.cc
    failure_detector.cc
    gossiper.cc
    hinted_handoff.cc
    lsa.cc
    messaging_service.cc
    raft.cc
    storage_proxy.cc
    storage_service.cc
    stream_manager.cc
    system.cc
    tasks.cc
    task_manager.cc
    task_manager_test.cc
    token_metadata.cc
    ${swagger_gen_files})
target_include_directories(api
  PUBLIC
    ${CMAKE_SOURCE_DIR}
    ${scylla_gen_build_dir})
target_link_libraries(api
  PUBLIC
    Seastar::seastar
    xxHash::xxhash
  PRIVATE
    idl
    wasmtime_bindings
    absl::headers)

check_headers(check-headers api
  GLOB_RECURSE ${CMAKE_CURRENT_SOURCE_DIR}/*.hh)

=== auth/CMakeLists.txt ===
include(add_whole_archive)

add_library(scylla_auth STATIC)
target_sources(scylla_auth
  PRIVATE
    allow_all_authenticator.cc
    allow_all_authorizer.cc
    authenticated_user.cc
    authenticator.cc
    certificate_authenticator.cc
    common.cc
    default_authorizer.cc
    password_authenticator.cc
    passwords.cc
    permission.cc
    permissions_cache.cc
    resource.cc
    role_or_anonymous.cc
    roles-metadata.cc
    sasl_challenge.cc
    service.cc
    standard_role_manager.cc
    transitional.cc
    maintenance_socket_role_manager.cc)
target_include_directories(scylla_auth
  PUBLIC
    ${CMAKE_SOURCE_DIR})
target_link_libraries(scylla_auth
  PUBLIC
    Seastar::seastar
    xxHash::xxhash
  PRIVATE
    absl::headers
    cql3
    idl
    wasmtime_bindings
    libxcrypt::libxcrypt)

add_whole_archive(auth scylla_auth)

check_headers(check-headers scylla_auth
  GLOB_RECURSE ${CMAKE_CURRENT_SOURCE_DIR}/*.hh)

=== cdc/CMakeLists.txt ===
add_library(cdc STATIC)
target_sources(cdc
  PRIVATE
    cdc_partitioner.cc
    generation.cc
    log.cc
    metadata.cc
    split.cc)
target_include_directories(cdc
  PUBLIC
    ${CMAKE_SOURCE_DIR})
target_link_libraries(cdc
  PUBLIC
    absl::headers
    Seastar::seastar
    xxHash::xxhash
  PRIVATE
    replica)

check_headers(check-headers cdc
  GLOB_RECURSE ${CMAKE_CURRENT_SOURCE_DIR}/*.hh)

=== compaction/CMakeLists.txt ===
add_library(compaction STATIC)
target_sources(compaction
  PRIVATE
    compaction.cc
    compaction_manager.cc
    compaction_strategy.cc
    leveled_compaction_strategy.cc
    size_tiered_compaction_strategy.cc
    task_manager_module.cc
    time_window_compaction_strategy.cc)
target_include_directories(compaction
  PUBLIC
    ${CMAKE_SOURCE_DIR})
target_link_libraries(compaction
  PUBLIC
    Seastar::seastar
    xxHash::xxhash
  PRIVATE
    mutation_writer
    replica)

check_headers(check-headers compaction
  GLOB_RECURSE ${CMAKE_CURRENT_SOURCE_DIR}/*.hh)

=== cql3/CMakeLists.txt ===
include(generate_cql_grammar)

find_package(ANTLR3 REQUIRED)

generate_cql_grammar(
  GRAMMAR Cql.g
  SOURCES cql_grammar_srcs)
set_source_files_properties(${cql_grammar_srcs}
  PROPERTIES
    COMPILE_OPTIONS "-Wno-uninitialized;-Wno-parentheses-equality")

set(cql_parser_srcs ${cql_grammar_srcs})
list(FILTER cql_parser_srcs INCLUDE REGEX "Parser.cpp$")

set(unoptimized_modes "Coverage,Debug,Sanitize")
set(sanitized_modes "Debug,Sanitize")
set_property(
    SOURCE ${cql_parser_srcs}
    APPEND
    PROPERTY COMPILE_OPTIONS
      # Unoptimized parsers end up using huge amounts of stack space and
      # overflowing their stack
      $<$<CONFIG:${unoptimized_modes}>:-O1>
      # use-after-scope sanitizer also uses large amount of stack space
      # and overflows the stack of CqlParser
      $<$<CONFIG:${sanitized_modes}>:-fsanitize-address-use-after-scope>)

add_library(cql3 STATIC)
target_sources(cql3
  PRIVATE
    type_json.cc
    attributes.cc
    cf_name.cc
    cql3_type.cc
    description.cc
    operation.cc
    index_name.cc
    keyspace_element_name.cc
    lists.cc
    sets.cc
    maps.cc
    values.cc
    expr/expression.cc
    expr/restrictions.cc
    expr/prepare_expr.cc
    functions/user_function.cc
    functions/functions.cc
    functions/aggregate_fcts.cc
    functions/castas_fcts.cc
    functions/error_injection_fcts.cc
    statements/cf_prop_defs.cc
    statements/cf_statement.cc
    statements/authentication_statement.cc
    statements/create_keyspace_statement.cc
    statements/create_table_statement.cc
    statements/create_view_statement.cc
    statements/create_type_statement.cc
    statements/create_function_statement.cc
    statements/create_aggregate_statement.cc
    statements/drop_index_statement.cc
    statements/drop_keyspace_statement.cc
    statements/drop_table_statement.cc
    statements/drop_view_statement.cc
    statements/drop_type_statement.cc
    statements/drop_function_statement.cc
    statements/drop_aggregate_statement.cc
    statements/schema_altering_statement.cc
    statements/ks_prop_defs.cc
    statements/function_statement.cc
    statements/modification_statement.cc
    statements/cas_request.cc
    statements/raw/parsed_statement.cc
    statements/property_definitions.cc
    statements/update_statement.cc
    statements/strongly_consistent_modification_statement.cc
    statements/strongly_consistent_select_statement.cc
    statements/delete_statement.cc
    statements/prune_materialized_view_statement.cc
    statements/batch_statement.cc
    statements/select_statement.cc
    statements/use_statement.cc
    statements/index_prop_defs.cc
    statements/index_target.cc
    statements/create_index_statement.cc
    statements/truncate_statement.cc
    statements/alter_table_statement.cc
    statements/alter_view_statement.cc
    statements/list_users_statement.cc
    statements/authorization_statement.cc
    statements/permission_altering_statement.cc
    statements/list_permissions_statement.cc
    statements/grant_statement.cc
    statements/revoke_statement.cc
    statements/alter_type_statement.cc
    statements/alter_keyspace_statement.cc
    statements/role-management-statements.cc
    statements/service_level_statement.cc
    statements/create_service_level_statement.cc
    statements/alter_service_level_statement.cc
    statements/sl_prop_defs.cc
    statements/drop_service_level_statement.cc
    statements/attach_service_level_statement.cc
    statements/detach_service_level_statement.cc
    statements/list_service_level_statement.cc
    statements/list_service_level_attachments_statement.cc
    statements/list_effective_service_level_statement.cc
    statements/describe_statement.cc
    update_parameters.cc
    util.cc
    ut_name.cc
    role_name.cc
    column_identifier.cc
    column_specification.cc
    constants.cc
    query_processor.cc
    query_options.cc
    user_types.cc
    untyped_result_set.cc
    selection/selectable.cc
    selection/selection.cc
    selection/selector.cc
    restrictions/statement_restrictions.cc
    result_set.cc
    prepare_context.cc
    ${cql_grammar_srcs})
target_include_directories(cql3
  PUBLIC
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_BINARY_DIR})
target_link_libraries(cql3
  PUBLIC
    idl
    wasmtime_bindings
    Seastar::seastar
    absl::headers
    xxHash::xxhash
    ANTLR3::antlr3
  PRIVATE
    lang
    transport)

check_headers(check-headers cql3
  GLOB_RECURSE ${CMAKE_CURRENT_SOURCE_DIR}/*.hh)

=== data_dictionary/CMakeLists.txt ===
add_library(data_dictionary STATIC)
target_sources(data_dictionary
  PRIVATE
    data_dictionary.cc)
target_include_directories(data_dictionary
  PUBLIC
    ${CMAKE_SOURCE_DIR})
target_link_libraries(data_dictionary
  PRIVATE
    cql3
  PUBLIC
    Seastar::seastar
    xxHash::xxhash)

check_headers(check-headers data_dictionary
  GLOB_RECURSE ${CMAKE_CURRENT_SOURCE_DIR}/*.hh)

=== db/CMakeLists.txt ===
add_library(db STATIC)
target_sources(db
  PRIVATE
    consistency_level.cc
    system_keyspace.cc
    virtual_table.cc
    virtual_tables.cc
    system_distributed_keyspace.cc
    size_estimates_virtual_reader.cc
    schema_applier.cc
    schema_tables.cc
    cql_type_parser.cc
    legacy_schema_migrator.cc
    commitlog/commitlog.cc
    commitlog/commitlog_replayer.cc
    commitlog/commitlog_entry.cc
    data_listeners.cc
    functions/function.cc
    hints/internal/hint_endpoint_manager.cc
    hints/internal/hint_sender.cc
    hints/internal/hint_storage.cc
    hints/manager.cc
    hints/resource_manager.cc
    hints/host_filter.cc
    hints/sync_point.cc
    config.cc
    extensions.cc
    heat_load_balance.cc
    large_data_handler.cc
    marshal/type_parser.cc
    batchlog_manager.cc
    tags/utils.cc
    view/view.cc
    view/view_update_generator.cc
    view/row_locking.cc
    sstables-format-selector.cc
    snapshot-ctl.cc
    snapshot/backup_task.cc
    rate_limiter.cc
    per_partition_rate_limit_options.cc)
target_include_directories(db
  PUBLIC
    ${CMAKE_SOURCE_DIR})
target_link_libraries(db
  PUBLIC
    mutation
    Seastar::seastar
    xxHash::xxhash
    absl::headers
  PRIVATE
    data_dictionary
    cql3)

check_headers(check-headers db
  GLOB_RECURSE ${CMAKE_CURRENT_SOURCE_DIR}/*.hh)

=== dht/CMakeLists.txt ===
include(add_whole_archive)

add_library(scylla_dht STATIC)
target_sources(scylla_dht
  PRIVATE
    boot_strapper.cc
    i_partitioner.cc
    murmur3_partitioner.cc
    range_streamer.cc
    token.cc)
target_include_directories(scylla_dht
  PUBLIC
    ${CMAKE_SOURCE_DIR})
target_link_libraries(scylla_dht
  PUBLIC
    Seastar::seastar
    xxHash::xxhash
  PRIVATE
    replica)

add_whole_archive(dht scylla_dht)

check_headers(check-headers scylla_dht
  GLOB_RECURSE ${CMAKE_CURRENT_SOURCE_DIR}/*.hh)

=== dist/CMakeLists.txt ===
set(unstripped_dist_pkg
  ${CMAKE_BINARY_DIR}/$<CONFIG>/dist/tar/${Scylla_PRODUCT}-unstripped-${Scylla_VERSION}-${Scylla_RELEASE}.${CMAKE_SYSTEM_PROCESSOR}.tar.gz)
add_custom_command(
  OUTPUT ${unstripped_dist_pkg}
  COMMAND
    scripts/create-relocatable-package.py
      --build-dir ${CMAKE_BINARY_DIR}/$<CONFIG>
      --node-exporter-dir ${CMAKE_BINARY_DIR}/node_exporter
      --debian-dir ${CMAKE_BINARY_DIR}/debian
      ${unstripped_dist_pkg}
  DEPENDS
    ${CMAKE_BINARY_DIR}/$<CONFIG>/scylla
    ${CMAKE_BINARY_DIR}/$<CONFIG>/iotune
    ${CMAKE_BINARY_DIR}/node_exporter/node_exporter
    ${CMAKE_BINARY_DIR}/debian
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

add_custom_target(dist-server-deb ALL
  # the --builddir should match the paths specified by
  # "packages" in dist/docker/debian/build_docker.sh
  COMMAND reloc/build_deb.sh
    --reloc-pkg ${unstripped_dist_pkg}
    --builddir ${CMAKE_CURRENT_BINARY_DIR}/$<CONFIG>/debian
  DEPENDS ${unstripped_dist_pkg}
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
add_custom_target(dist-server-rpm ALL
  COMMAND reloc/build_rpm.sh
    --reloc-pkg ${unstripped_dist_pkg}
    --builddir ${CMAKE_CURRENT_BINARY_DIR}/$<CONFIG>/redhat
  DEPENDS ${unstripped_dist_pkg}
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
add_custom_target(dist-server
  DEPENDS dist-server-deb dist-server-rpm)

function(add_stripped name)
  # ${name} must be an absolute path
  add_custom_command(
    OUTPUT
      ${name}.debug
      ${name}.stripped
    COMMAND ${CMAKE_SOURCE_DIR}/scripts/strip.sh ${name}
    DEPENDS ${name})
endfunction()

add_stripped("${CMAKE_BINARY_DIR}/$<CONFIG>/scylla")

# app_iotune is located in seastar/apps/iotune
if(TARGET Seastar::iotune)
  set(iotune_src "$<TARGET_FILE:Seastar::iotune>")
else()
  set(iotune_src "$<TARGET_FILE:app_iotune>")
endif()
set(iotune_dst "${CMAKE_BINARY_DIR}/$<CONFIG>/iotune")
add_custom_command(
  OUTPUT "${iotune_dst}"
  COMMAND ${CMAKE_COMMAND} -E copy "${iotune_src}" "${iotune_dst}"
  DEPENDS $<OUTPUT_CONFIG:${iotune_src}>)
add_stripped("${iotune_dst}")

find_program(TAR_COMMAND tar
  REQUIRED)
execute_process(
  COMMAND
    ${CMAKE_SOURCE_DIR}/install-dependencies.sh --print-node-exporter-filename
  OUTPUT_VARIABLE
    node_exporter_filename
  OUTPUT_STRIP_TRAILING_WHITESPACE)
add_custom_command(
  OUTPUT
    ${CMAKE_BINARY_DIR}/node_exporter/node_exporter
  COMMAND
    ${CMAKE_COMMAND} -E make_directory ${CMAKE_BINARY_DIR}/node_exporter
  COMMAND
    ${TAR_COMMAND}
      -C ${CMAKE_BINARY_DIR}/node_exporter
      -xpf ${node_exporter_filename}
      --no-same-owner
      --strip-components=1)
add_stripped(${CMAKE_BINARY_DIR}/node_exporter/node_exporter)

add_custom_command(
  OUTPUT ${CMAKE_BINARY_DIR}/debian
  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/debian/debian_files_gen.py
    --build-dir ${CMAKE_BINARY_DIR}
    --output-dir ${CMAKE_BINARY_DIR}/debian
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

set(stripped_dist_pkg
  "${CMAKE_BINARY_DIR}/$<CONFIG>/dist/tar/${Scylla_PRODUCT}-${Scylla_VERSION}-${Scylla_RELEASE}.${CMAKE_SYSTEM_PROCESSOR}.tar.gz")
add_custom_command(
  OUTPUT
    ${stripped_dist_pkg}
  COMMAND
    ${CMAKE_SOURCE_DIR}/scripts/create-relocatable-package.py
      --stripped
      --build-dir ${CMAKE_BINARY_DIR}/$<CONFIG>
      --node-exporter-dir ${CMAKE_BINARY_DIR}/node_exporter
      --debian-dir ${CMAKE_BINARY_DIR}/debian
      ${stripped_dist_pkg}
  DEPENDS
    ${CMAKE_BINARY_DIR}/$<CONFIG>/scylla.stripped
    ${CMAKE_BINARY_DIR}/$<CONFIG>/iotune.stripped
    ${CMAKE_BINARY_DIR}/node_exporter/node_exporter.stripped
    ${CMAKE_BINARY_DIR}/debian
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
add_custom_target(dist-server-tar
  DEPENDS ${stripped_dist_pkg})
add_custom_target(package
  ${CMAKE_COMMAND} -E copy ${stripped_dist_pkg} ${CMAKE_CURRENT_BINARY_DIR}/$<CONFIG>/${Scylla_PRODUCT}-package.tar.gz
  DEPENDS ${stripped_dist_pkg})


set(dist_pkgs
  "${stripped_dist_pkg}")
dist_submodule(cqlsh cqlsh dist_pkgs)
dist_submodule(tools java dist_pkgs
  NOARCH)
dist_submodule(python3 python3 dist_pkgs)
set(unified_dist_pkg
  "${CMAKE_BINARY_DIR}/$<CONFIG>/dist/tar/${Scylla_PRODUCT}-unified-${Scylla_VERSION}-${Scylla_RELEASE}.${CMAKE_SYSTEM_PROCESSOR}.tar.gz")
add_custom_command(
  OUTPUT
    "${unified_dist_pkg}"
  COMMAND
    ${CMAKE_SOURCE_DIR}/unified/build_unified.sh
      --build-dir ${CMAKE_BINARY_DIR}/$<CONFIG>
      --pkgs "${dist_pkgs}"
      --unified-pkg ${unified_dist_pkg}
  DEPENDS
    ${dist_pkgs}
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  VERBATIM)
add_custom_target(dist-unified ALL
  DEPENDS ${unified_dist_pkg})

add_custom_target(dist)
add_dependencies(dist
  dist-cqlsh
  dist-tools
  dist-python3
  dist-server)

add_subdirectory(debuginfo)

=== docs/Makefile ===
# Global variables
# You can set these variables from the command line.
POETRY        := PYTHON_KEYRING_BACKEND=keyring.backends.null.Keyring poetry
SPHINXOPTS    := -j auto
SPHINXBUILD   := $(POETRY) run sphinx-build
PAPER         :=
BUILDDIR      := _build
SOURCEDIR     := .
PREVIEW_HOST  := 127.0.0.1
FLAG          := opensource
CONF_PATH     := ./

# Internal variables
ifeq ($(FLAG), enterprise)
    CONF_PATH = ./_enterprise
endif

PAPEROPT_a4     := -D latex_paper_size=a4
PAPEROPT_letter := -D latex_paper_size=letter
ALLSPHINXOPTS   := -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) $(SOURCEDIR) -t $(FLAG) -c $(CONF_PATH)
TESTSPHINXOPTS  := $(ALLSPHINXOPTS) -W --keep-going
PROD_OPTS       := -D html_theme_options.collapse_navigation='false' -D html_theme_options.navigation_depth=3 -t $(FLAG) -c $(CONF_PATH)

.PHONY: all
all: dirhtml

# Setup commands
.PHONY: setupenv
setupenv:
	pip install -q 'poetry>=1.8.0'

.PHONY: setup
setup:
	$(POETRY) install

.PHONY: update
update:
	$(POETRY) update

# Clean commands
.PHONY: pristine
pristine: clean
	git clean -dfX

.PHONY: clean
clean:
	rm -rf $(BUILDDIR)/*
	rm -rf _data/*

# Generate output commands
.PHONY: dirhtml
dirhtml: setup
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

.PHONY: singlehtml
singlehtml: setup
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

.PHONY: epub
epub: setup
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

.PHONY: epub3
epub3: setup
	$(SPHINXBUILD) -b epub3 $(ALLSPHINXOPTS) $(BUILDDIR)/epub3
	@echo
	@echo "Build finished. The epub3 file is in $(BUILDDIR)/epub3."

.PHONY: multiversion
multiversion: setup
	$(POETRY) run sphinx-multiversion $(SOURCEDIR) $(BUILDDIR)/dirhtml $(PROD_OPTS)
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

.PHONY: redirects
redirects: setup
	$(POETRY) run redirects-cli fromfile --yaml-file ./_utils/redirects.yaml --output-dir $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

# Preview commands
.PHONY: preview
preview: setup
	$(POETRY) run sphinx-autobuild -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml --host $(PREVIEW_HOST) --port 5500 --ignore *.csv --ignore *.json --ignore *.yaml

.PHONY: multiversionpreview
multiversionpreview: multiversion
	$(POETRY) run python -m http.server 5500 --directory $(BUILDDIR)/dirhtml

# Test commands
.PHONY: test
test: setup
	$(SPHINXBUILD) -b dirhtml $(TESTSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

.PHONY: linkcheck
linkcheck: setup
	$(SPHINXBUILD) -b linkcheck $(SOURCEDIR) $(BUILDDIR)/linkcheck

=== dist/common/dep/scylla-env-1.0/debian/changelog ===
scylla-env (1.0-ubuntu1) trusty; urgency=medium

  * Initial release.

 -- Takuya ASADA <syuu@scylladb.com>  Mon, 09 May 2016 18:32:52 +0000

=== dist/common/dep/scylla-env-1.0/debian/control ===
Source: scylla-env
Maintainer: Takuya ASADA <syuu@scylladb.com>
Section: misc
Priority: optional
Standards-Version: 1.0
Build-Depends: debhelper (>= 9)

Package: scylla-env
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: language tool for constructing recognizers, compilers etc
 A language tool that provides a framework for constructing recognizers, interpreters, compilers, and translators from grammatical descriptions containing actions in a variety of target languages.

=== dist/debian/debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export PYBUILD_DISABLE=1
ifneq ($(findstring housekeeping, $(DEB_BUILD_OPTIONS)),)
    install_arg := --housekeeping
else
    install_arg :=
endif

product := $(subst -server,,$(DEB_SOURCE))

override_dh_auto_configure:

override_dh_auto_build:

override_dh_auto_clean:

override_dh_auto_install:
	dh_auto_install
	./scylla/install.sh --packaging --root "$(CURDIR)/debian/tmp" $(install_arg) --sysconfdir "/etc/default"
	# don't use default sysconfig file, use Debian version
	cp scylla/dist/debian/sysconfig/scylla-housekeeping $(CURDIR)/debian/tmp/etc/default/

override_dh_installinit:
ifeq ($(product),scylla)
	dh_installinit --no-start
else
	dh_installinit --no-start --name scylla-server
	dh_installinit --no-start --name scylla-node-exporter
endif
	dh_installinit --no-start --name scylla-housekeeping-daily
	dh_installinit --no-start --name scylla-housekeeping-restart
	dh_installinit --no-start --name scylla-fstrim
	dh_installinit --no-start --name scylla-tune-sched

override_dh_strip:
	# The binaries (ethtool...patchelf) don't pass dh_strip after going through patchelf. Since they are
	# already stripped, nothing is lost if we exclude them, so that's what we do.
	dh_strip -Xlibprotobuf.so.15 -Xld.so -Xethtool -Xgawk -Xgzip -Xhwloc-calc -Xhwloc-distrib -Xifconfig -Xlscpu -Xnetstat -Xpatchelf --dbg-package=$(product)-server-dbg
	find $(CURDIR)/debian/$(product)-server-dbg/usr/lib/debug/.build-id/ -name "*.debug" -exec objcopy --decompress-debug-sections {} \;

override_dh_makeshlibs:

override_dh_shlibdeps:

override_dh_fixperms:
	dh_fixperms
	chmod 755 $(CURDIR)/debian/$(product)-server/opt/scylladb/libreloc/ld.so

override_dh_strip_nondeterminism:

%:
	dh $@
